      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************
;     library includes.
;**********************************************************************
       include \Altra32\include\windows.inc
       include \Altra32\include\user32.inc
       include \Altra32\include\kernel32.inc



;**********************************************************************
; Local macros
;**********************************************************************
include \altra32\macros\macros.asm
include protos.inc

BOOTSECTOR STRUC
bootsecJmp    db ?,?,?
OemName       db 8 dup (?)    ; name and version.
BytesPerSec   dw ?            ; bytes per sector.
SecPerClust   db ?            ; sectors per cluster.
ResSectors    dw ?            ; number of reserved sectors.
FATs          db ?            ; number of FATs.
RootDirEnts   dw ?            ; number of root directory entries.
sectors       dw ?            ; total number of sectors.
Media         db ?            ; media descriptor byte. (0F0h for floppies)
FATsecs       dw ?            ; number of sectors per FAT.
SecPerTrack   dw ?            ; sectors per track.
Heads         dw ?            ; number of heads.
HiddenSecs    dd ?            ; number of hidden sectors.
HugeSectors   dd ?            ; number of sectors if Sectors equals 0.
DriveNumber   db ?
Reserved1     db ?
BootSignature db ?
VolumeID      dd ?
VolumeLabel   db 11 dup (?)
FileSysType   db 8 dup (?)
extra         dw ?
BOOTSECTOR ENDS

DIRENTRY STRUC
FileName        db '????????'   ;name
Extension       db '???'        ;extension
Attributes      db ?            ;attributes
Reserved        db 10 dup (?)   ;reserved
Time            dw ?            ;time stamp
Date            dw ?            ;date stamp
StartCluster    dw ?            ;starting cluster
FileSize        dd ?            ;file size
DIRENTRY ENDS



extern hsector:DWORD
extern hcreate:DWORD
extern hbyteread:DWORD
extern hproggres:DWORD
extern hdriveA:DWORD
extern hdriveB:DWORD
extern FileName:DWORD
extern ReadDrive:BYTE
extern sector:DWORD
extern max_sectors:DWORD
extern hwriteimage:DWORD

.data
img_size         dd 0
bytestotal       dd 0
open_drive_cmd   db '\\.\\'
drive            db 'A'
                 db ':',0
floppy_size      dd 0
writebuffer      dd 0
buffer_pointer   dd 0
hDevice          dd 0
bytesread        dd 512
secshow          db 'Writing Sector: '
sector_text      db 128 Dup(?)
totalshow        db 'Bytes Written: '
total_text       db 128 Dup(?)
.data?
bootsec          db 513 Dup(?)

; sector size on CD's is 2048
; to read CD's goto sector 16 read dword at 50h
; to get the logical sector size of the whole CD data.
; also at 28h is where the CD's volume lable is.

.code
;***********************************************************************
;
;
;***********************************************************************
write_floppy_img proc hWin:DWORD

                mov al,[ReadDrive]
                mov [drive],al
                invoke EnableWindow,hcreate,FALSE
                invoke EnableWindow,hdriveA,FALSE
                invoke EnableWindow,hdriveB,FALSE
                invoke EnableWindow,hwriteimage,FALSE
                mov [hDevice],FUNC(CreateFile,addr open_drive_cmd,GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE,NULL, OPEN_EXISTING, 0, NULL)
                .if [hDevice] == INVALID_HANDLE_VALUE
                    invoke MessageBox,hWin,txt("Floppy Disk not ready."),txt("Disk Access Error"),MB_OK
                    invoke EnableWindow,hcreate,TRUE
                    invoke EnableWindow,hdriveA,TRUE
                    invoke EnableWindow,hdriveB,TRUE
                    invoke EnableWindow,hwriteimage,TRUE
                    return -1
                .endif
                invoke SetFilePointer,hDevice,0,NULL,FILE_BEGIN
                .if eax == INVALID_SET_FILE_POINTER
                    invoke MessageBox,hWin,txt("Error reading boot sector."),txt("Read Disk Error"),MB_OK
                    invoke EnableWindow,hcreate,TRUE
                    invoke EnableWindow,hdriveA,TRUE
                    invoke EnableWindow,hdriveB,TRUE
                    invoke EnableWindow,hwriteimage,TRUE
                    invoke CloseHandle,hDevice
                    return -1
                .endif
                invoke ReadFile,hDevice,addr bootsec,512,addr bytesread,0
                .if [bytesread] != 512
                    invoke MessageBox,hWin,txt("Disk read error."),txt("Disk Error"),MB_OK
                    invoke EnableWindow,hcreate,TRUE
                    invoke EnableWindow,hdriveA,TRUE
                    invoke EnableWindow,hdriveB,TRUE
                    invoke EnableWindow,hwriteimage,TRUE
                    invoke CloseHandle,hDevice
                    return -1
                .endif
                mov [writebuffer],FUNC(read_disk_file,addr FileName,addr img_size)
                mov ebx,offset bootsec
                xor edx,edx
                xor eax,eax
                mov ax,[ebx].BOOTSECTOR.sectors
                mov [max_sectors],eax
                mov ecx,512
                mul ecx
                mov [floppy_size],eax               
                mov eax,[writebuffer]
                mov [buffer_pointer],eax
                mov [sector],0  
                mov eax,[max_sectors]
                shl eax,16
                invoke SendMessage,hproggres,PBM_SETRANGE,0,eax
                invoke SendMessage,hproggres,PBM_SETSTEP,1,0

                mov ebx,[writebuffer]
                xor edx,edx
                xor eax,eax
                mov ax,[ebx].BOOTSECTOR.sectors
                .if eax != [max_sectors]
                    invoke MessageBox,hWin,txt("Error, Image file is different then floppy disk.",0dh,0ah,"Insert another floppy or reformat this floopy, and try again."),txt("Media Error."),MB_OK or MB_ICONHAND
                    invoke EnableWindow,hcreate,TRUE
                    invoke EnableWindow,hdriveA,TRUE
                    invoke EnableWindow,hdriveB,TRUE
                    invoke EnableWindow,hwriteimage,TRUE
                    invoke CloseHandle,hDevice
                    invoke I_HeapFree,writebuffer
                    return -1
                .endif

                mov ebx,[max_sectors]
                .while sector != ebx
                       xor edx,edx
                       mov ecx,512
                       mov eax,[sector]
                       mul ecx
                       mov [bytestotal],eax
                       invoke dw2ac,[sector],addr sector_text
                       invoke SetWindowText,hsector,addr secshow
                       invoke SetWindowText,hbyteread,addr totalshow
                       invoke dw2ac,[bytestotal],addr total_text
                       invoke SendMessage,hproggres,PBM_STEPIT,0,0
                       mov eax,[sector]
                       xor edx,edx
                       mov ecx,512
                       mul ecx
                       invoke SetFilePointer,hDevice,eax,NULL,FILE_BEGIN
                       invoke WriteFile,hDevice,buffer_pointer,512,addr bytesread,0
                       mov ebx,[max_sectors]
                       add [buffer_pointer],512
                       inc sector
                .endw
                invoke I_HeapFree,[writebuffer]
                invoke SetFilePointer,hDevice,0,NULL,FILE_BEGIN
                .if eax == INVALID_SET_FILE_POINTER
                    invoke MessageBox,hWin,txt("Error reading boot sector."),txt("Disk Error"),MB_OK
                    invoke EnableWindow,hcreate,TRUE
                    invoke EnableWindow,hdriveA,TRUE
                    invoke EnableWindow,hdriveB,TRUE
                    invoke EnableWindow,hwriteimage,TRUE
                    invoke CloseHandle,hDevice
                    return -1
                .endif
                invoke ReadFile,hDevice,addr bootsec,512,addr bytesread,0
                .if [bytesread] != 512
                    invoke MessageBox,hWin,txt("Disk read error."),txt("Disk Error"),MB_OK
                    invoke EnableWindow,hcreate,TRUE
                    invoke EnableWindow,hdriveA,TRUE
                    invoke EnableWindow,hdriveB,TRUE
                    invoke EnableWindow,hwriteimage,TRUE
                    invoke CloseHandle,hDevice
                    return -1
                .endif
                invoke CloseHandle,hDevice
                invoke EnableWindow,hcreate,TRUE
                invoke EnableWindow,hdriveA,TRUE
                invoke EnableWindow,hdriveB,TRUE
                invoke EnableWindow,hwriteimage,TRUE
                ret
write_floppy_img endp


end


